--- old/usr/src/lib/libc/i386/gen/makectxt.c	2015-12-18 13:15:27.022247371 -0500
+++ new/usr/src/lib/libc/i386/gen/makectxt.c	2015-12-18 13:15:27.026179266 -0500
@@ -49,9 +49,9 @@
  * aligned before a function call (STACK_ALIGN == 4).  The ABI supplement
  * version 1.0 changed the required alignment to 16-byte for the benefit of
  * floating point code compiled using sse2.  The compiler assumes this
- * alignment and maintains it for calls made from that function.  If the
- * stack is initially properly aligned, it will continue to be so aligned.
- * If it is not initially so aligned, it will never become so aligned.
+ * alignment and maintains it for calls it generates.  If the stack is
+ * initially properly aligned, it will continue to be so aligned.  If it is
+ * not initially so aligned, it will never become so aligned.
  *
  * One slightly confusing detail to keep in mind is that the 16-byte
  * alignment (%esp & 0xf == 0) is true just *before* the call instruction.
@@ -87,19 +87,24 @@
 	tsp = (long *)(((uintptr_t)ucp->uc_stack.ss_sp +
 	    ucp->uc_stack.ss_size - size) & ~(STACK_ALIGN - 1));
 
+	/*
+	 * Since we're emulating the call instruction, we must push the
+	 * return address (which involves adjusting the stack pointer to
+	 * have the proper 4-byte bias).
+	 */
 	sp = tsp - 1;
 
-	va_start(ap, argc);
-
-	while (argc-- > 0) {
-		*tsp++ = va_arg(ap, long);
-	}
-
-	va_end(ap);
-
 	*sp = (long)resumecontext;		/* return address */
 
 	ucp->uc_mcontext.gregs[UESP] = (greg_t)sp;
+
+	/*
+	 * "push" all the arguments
+	 */
+	va_start(ap, argc);
+	while (argc-- > 0)
+		*tsp++ = va_arg(ap, long);
+	va_end(ap);
 }
 
 
